#property copyright "Copyright  2012, Avatara@bigmir.net"
//     
//    
#property show_inputs
extern string SSymbol="";
extern int ExtPeriodMultiplier=2; // new period multiplier factor
extern int N=50000;
extern double startPos=10.0,Sigma=40.0;
int        ExtHandle=-1;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
   int    i, start_pos, i_time, time0, last_fpos, periodseconds;
   double d_open, d_low, d_high, d_close, d_volume, last_volume;
   int    hwnd=0,cnt=0;
//---- History header
   int    version=400;
   string c_copyright;
   string c_symbol=Symbol();//SSymbol;
   int    i_period=Period()*ExtPeriodMultiplier;
   int    i_digits=Digits;
   int    i_unused[13],RND;
//----  
   if (SSymbol!="") c_symbol=SSymbol;
   ExtHandle=FileOpenHistory(c_symbol+i_period+".hst", FILE_BIN|FILE_WRITE);
   if(ExtHandle < 0) return(-1);
//---- write history file header
   c_copyright="(C)opyright 2003, MetaQuotes Software Corp.";
   FileWriteInteger(ExtHandle, version, LONG_VALUE);
   FileWriteString(ExtHandle, c_copyright, 64);
   FileWriteString(ExtHandle, c_symbol, 12);
   FileWriteInteger(ExtHandle, i_period, LONG_VALUE);
   FileWriteInteger(ExtHandle, i_digits, LONG_VALUE);
   FileWriteInteger(ExtHandle, 0, LONG_VALUE);       //timesign
   FileWriteInteger(ExtHandle, 0, LONG_VALUE);       //last_sync
   FileWriteArray(ExtHandle, i_unused, 0, 13);
//---- write history file
   periodseconds=i_period*60;
   
   d_open=startPos;
   d_low=d_open;
   d_high=d_open;
   d_volume=1;
   MathSrand(TimeLocal());
   //---- normalize open time
   i_time=(TimeLocal()-N*periodseconds)/periodseconds;
   i_time*=periodseconds;
   while (cnt<N)
     {
      time0=i_time+periodseconds;
      
      //----
       i_time=time0/periodseconds;
            i_time*=periodseconds;
      if (TimeDayOfWeek(i_time)==0 || TimeDayOfWeek(i_time)==6) continue;      
         d_open=d_close;
         RND=MathRand();
         d_close+=NormalizeDouble(Sigma*Point*(RND/32767.0-0.5),
                 Digits);
        if (d_close<0.5) d_close=0.5;
         if (d_close>d_open) d_low=d_open-0.8*Sigma*Point;
                  else d_low=d_close-0.2*Sigma*Point;
         if (d_close>d_open) d_high=d_close+0.6*Sigma*Point;
                  else d_high=d_open+0.1*Sigma*Point;
         d_volume=1+RND/1000.0;
         FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
         FileWriteDouble(ExtHandle, d_open, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_low, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_high, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_close, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_volume, DOUBLE_VALUE);
         FileFlush(ExtHandle);
         cnt++;
       
     } 
   FileFlush(ExtHandle);
   Print(cnt," record(s) written");

   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void deinit()
  {
   if(ExtHandle>=0) { FileClose(ExtHandle); ExtHandle=-1; }
  }
//+------------------------------------------------------------------+